 /*
  *
  * Piecewise-constant reserved option word.
  *
  * Paul Ausbeck 2/20/98
  */

#define _INC_PWCFILE

#ifndef _INC_IFILELIB
#include "ifilelib.h"
#endif

/* Reserved word for coding options. */

class pwc_options
{
  unsigned int flags : 8;
  unsigned int lps_max : 8;
  unsigned int reserved : 16;

public:
  enum options { gray = 0x1, noq2 = 0x2, noq5 = 0x4 };

  pwc_options(int flags = 0, int lps_max = 7) 
  { 
    this->flags = flags;
    this->lps_max = lps_max;
    this->reserved = 16;
  }
  unsigned int binary_form(void) { return flags; }
  int max_lps(void) { return lps_max; }
  void set_flags(int flags)
  {
    this->flags = flags;
  }
};

class pwc_header
{
  class pwc_options header;

  int bytes_read;

public:
  void init(void) { bytes_read = 0;}

  pwc_header(pwc_options &options) { init(); header = options; }
  pwc_header(ifile_io_wrapper *file) { init(); read(file); }

  static int header_size(void) { return sizeof(pwc_options); }

  int read(ifile_io_wrapper *file) 
  { 
    return bytes_read += file->read(this + bytes_read, sizeof(header) - bytes_read); 
  }
  int write(ifile_io_wrapper *file) { return file->write(this, sizeof(header)); }

  pwc_options &options(void) { return header; }
};


